javax.persistence

## Interface EntityGraph<T>

Type Parameters:
  `T` - The type of the root entity.

    public interface EntityGraph<T>

This type represents the root of an entity graph that will be used as a template to define the attribute nodes and boundaries of a graph of entities and entity relationships. The root must be an entity type.

The methods to add subgraphs implicitly create the corresponding attribute nodes as well; such attribute nodes should not be redundantly specified.

Since:
  Java Persistence 2.1
See Also:
  `AttributeNode`, `Subgraph`, `NamedEntityGraph`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addAttributeNodes(Attribute<T,?>... attribute)` Add one or more attribute nodes to the entity graph.
`void` `addAttributeNodes(String... attributeName)` Add one or more attribute nodes to the entity graph.
`<X> Subgraph<X>` `addKeySubgraph(Attribute<T,X> attribute)` Add a node to the graph that corresponds to a map key that is a managed type.
`<X> Subgraph<? extends X>` `addKeySubgraph(Attribute<T,X> attribute, Class<? extends X> type)` Add a node to the graph that corresponds to a map key that is a managed type with inheritance.
`<X> Subgraph<X>` `addKeySubgraph(String attributeName)` Add a node to the graph that corresponds to a map key that is a managed type.
`<X> Subgraph<X>` `addKeySubgraph(String attributeName, Class<X> type)` Add a node to the graph that corresponds to a map key that is a managed type with inheritance.
`<T> Subgraph<? extends T>` `addSubclassSubgraph(Class<? extends T> type)` Add additional attributes to this entity graph that correspond to attributes of subclasses of this EntityGraph's entity type.
`<X> Subgraph<X>` `addSubgraph(Attribute<T,X> attribute)` Add a node to the graph that corresponds to a managed type.
`<X> Subgraph<? extends X>` `addSubgraph(Attribute<T,X> attribute, Class<? extends X> type)` Add a node to the graph that corresponds to a managed type with inheritance.
`<X> Subgraph<X>` `addSubgraph(String attributeName)` Add a node to the graph that corresponds to a managed type.
`<X> Subgraph<X>` `addSubgraph(String attributeName, Class<X> type)` Add a node to the graph that corresponds to a managed type with inheritance.
`List<AttributeNode<?>>` `getAttributeNodes()` Return the attribute nodes of this entity that are included in the entity graph.
`String` `getName()` Return the name of a named EntityGraph (an entity graph defined by means of the `NamedEntityGraph` annotation, XML descriptor element, or added by means of the `addNamedEntityGraph` method.

### Method Detail

#### getName

    String getName()

Return the name of a named EntityGraph (an entity graph defined by means of the `NamedEntityGraph` annotation, XML descriptor element, or added by means of the `addNamedEntityGraph` method. Returns null if the EntityGraph is not a named EntityGraph.

#### addAttributeNodes

    void addAttributeNodes(String... attributeName)

Add one or more attribute nodes to the entity graph.

Parameters:
  `attributeName` - name of the attribute
Throws:
  `IllegalArgumentException` - if the attribute is not an attribute of this entity.
  `IllegalStateException` - if the EntityGraph has been statically defined

#### addAttributeNodes

    void addAttributeNodes(Attribute<T,?>... attribute)

Add one or more attribute nodes to the entity graph.

Parameters:
  `attribute` - attribute
Throws:
  `IllegalStateException` - if the EntityGraph has been statically defined

#### addSubgraph

    <X> Subgraph<X> addSubgraph(Attribute<T,X> attribute)

Add a node to the graph that corresponds to a managed type. This allows for construction of multi-node entity graphs that include related managed types.

Parameters:
  `attribute` - attribute
Returns:
  subgraph for the attribute
Throws:
  `IllegalArgumentException` - if the attribute's target type is not a managed type
  `IllegalStateException` - if the EntityGraph has been statically defined

#### addSubgraph

    <X> Subgraph<? extends X> addSubgraph(Attribute<T,X> attribute,
                                          Class<? extends X> type)

Add a node to the graph that corresponds to a managed type with inheritance. This allows for multiple subclass subgraphs to be defined for this node of the entity graph. Subclass subgraphs will automatically include the specified attributes of superclass subgraphs.

Parameters:
  `attribute` - attribute
  `type` - entity subclass
Returns:
  subgraph for the attribute
Throws:
  `IllegalArgumentException` - if the attribute's target type is not a managed type
  `IllegalStateException` - if the EntityGraph has been statically defined

#### addSubgraph

    <X> Subgraph<X> addSubgraph(String attributeName)

Add a node to the graph that corresponds to a managed type. This allows for construction of multi-node entity graphs that include related managed types.

Parameters:
  `attributeName` - name of the attribute
Returns:
  subgraph for the attribute
Throws:
  `IllegalArgumentException` - if the attribute is not an attribute of this entity.
  `IllegalArgumentException` - if the attribute's target type is not a managed type
  `IllegalStateException` - if the EntityGraph has been statically defined

#### addSubgraph

    <X> Subgraph<X> addSubgraph(String attributeName,
                                Class<X> type)

Add a node to the graph that corresponds to a managed type with inheritance. This allows for multiple subclass subgraphs to be defined for this node of the entity graph. Subclass subgraphs will automatically include the specified attributes of superclass subgraphs.

Parameters:
  `attributeName` - name of the attribute
  `type` - entity subclass
Returns:
  subgraph for the attribute
Throws:
  `IllegalArgumentException` - if the attribute is not an attribute of this managed type.
  `IllegalArgumentException` - if the attribute's target type is not a managed type
  `IllegalStateException` - if this EntityGraph has been statically defined

#### addKeySubgraph

    <X> Subgraph<X> addKeySubgraph(Attribute<T,X> attribute)

Add a node to the graph that corresponds to a map key that is a managed type. This allows for construction of multi-node entity graphs that include related managed types.

Parameters:
  `attribute` - attribute
Returns:
  subgraph for the key attribute
Throws:
  `IllegalArgumentException` - if the attribute's target type is not an entity
  `IllegalStateException` - if this EntityGraph has been statically defined

#### addKeySubgraph

    <X> Subgraph<? extends X> addKeySubgraph(Attribute<T,X> attribute,
                                             Class<? extends X> type)

Add a node to the graph that corresponds to a map key that is a managed type with inheritance. This allows for construction of multi-node entity graphs that include related managed types. Subclass subgraphs will include the specified attributes of superclass subgraphs.

Parameters:
  `attribute` - attribute
  `type` - entity subclass
Returns:
  subgraph for the key attribute
Throws:
  `IllegalArgumentException` - if the attribute's target type is not an entity
  `IllegalStateException` - if this EntityGraph has been statically defined

#### addKeySubgraph

    <X> Subgraph<X> addKeySubgraph(String attributeName)

Add a node to the graph that corresponds to a map key that is a managed type. This allows for construction of multi-node entity graphs that include related managed types.

Parameters:
  `attributeName` - name of the attribute
Returns:
  subgraph for the key attribute
Throws:
  `IllegalArgumentException` - if the attribute is not an attribute of this entity.
  `IllegalArgumentException` - if the attribute's target type is not an entity
  `IllegalStateException` - if this EntityGraph has been statically defined

#### addKeySubgraph

    <X> Subgraph<X> addKeySubgraph(String attributeName,
                                   Class<X> type)

Add a node to the graph that corresponds to a map key that is a managed type with inheritance. This allows for construction of multi-node entity graphs that include related managed types. Subclass subgraphs will automatically include the specified attributes of superclass subgraphs

Parameters:
  `attributeName` - name of the attribute
  `type` - entity subclass
Returns:
  subgraph for the key attribute
Throws:
  `IllegalArgumentException` - if the attribute is not an attribute of this entity.
  `IllegalArgumentException` - if the attribute's target type is not a managed type
  `IllegalStateException` - if this EntityGraph has been statically defined

#### addSubclassSubgraph

    <T> Subgraph<? extends T> addSubclassSubgraph(Class<? extends T> type)

Add additional attributes to this entity graph that correspond to attributes of subclasses of this EntityGraph's entity type. Subclass subgraphs will automatically include the specified attributes of superclass subgraphs.

Parameters:
  `type` - entity subclass
Returns:
  subgraph for the subclass
Throws:
  `IllegalArgumentException` - if the type is not an entity type
  `IllegalStateException` - if the EntityGraph has been statically defined

#### getAttributeNodes

    List<AttributeNode<?>> getAttributeNodes()

Return the attribute nodes of this entity that are included in the entity graph.

Returns:
  attribute nodes for the annotated entity type or empty list if none have been defined